﻿Imports System.Drawing
Imports System.ComponentModel

Namespace System.Windows.Forms
    <DesignerCategoryAttribute("Code")> _
    Public Class ContextMenuEx : Inherits ContextMenuStrip

        Private _OpenClickLocation As Point

        Public Sub New()
        End Sub

        ''' <summary>
        ''' the designer uses this constructor to reserve this component
        '''  as to dispose together with the Form
        ''' </summary>
        Public Sub New(ByVal container As IContainer)
            MyBase.New(container)
        End Sub

        ''' <summary>
        ''' mousePosition over the control, on which the ContextMenuEx 
        '''  last time was opened
        ''' </summary>
        Public ReadOnly Property OpenClickLocation() As Point
            Get
                Return _OpenClickLocation
            End Get
        End Property

        Protected Overrides Sub OnOpened(ByVal e As EventArgs)
            If SourceControl IsNot Nothing Then
                _OpenClickLocation = _
                    SourceControl.PointToClient(Control.MousePosition)
            End If
            MyBase.OnOpened(e)
        End Sub
    End Class

End Namespace
